<?php
helper::import(dirname(dirname(dirname(__FILE__))) . "/control.php");
class mycaselib extends caselib
{
    public function showImport($libID, $pagerID = 1, $maxImport = 0, $insert = '')
    {
        $this->loadModel('testcase');

        $file    = $this->session->fileImport;
        $tmpPath = $this->loadModel('file')->getPathOfImportedFile();
        $tmpFile = $tmpPath . DS . md5(basename($file));

        if($_POST)
        {
            $this->caselib->createFromImport($libID);
            if($this->post->isEndPage)
            {
                unlink($tmpFile);
                die(js::locate(inlink('browse', "libID=$libID"), 'parent'));
            }
            else
            {
                die(js::locate(inlink('showImport', "libID=$libID&pagerID=" . ($this->post->pagerID + 1) . "&maxImport=$maxImport&insert=" . zget($_POST, 'insert', '')), 'parent'));
            }
        }

        $libraries = $this->caselib->getLibraries();
        if(empty($libraries)) $this->locate(inlink('createLib'));

        $this->caselib->setLibMenu($libraries, $libID);

        $caseLang   = $this->lang->testcase;
        $caseConfig = $this->config->testcase;
        $modules    = $this->loadModel('tree')->getOptionMenu($libID, $viewType = 'caselib', $startModuleID = 0);

        if(!empty($maxImport) and file_exists($tmpFile))
        {
            $data = unserialize(file_get_contents($tmpFile));
            $caseData = $data['caseData'];
            $stepData = $data['stepData'];
        }
        else
        {
            $pagerID = 1;
            $fields  = explode(',', $caseConfig->exportFields);
            foreach($fields as $key => $fieldName)
            {
                $fieldName = trim($fieldName);
                $fields[$fieldName] = isset($caseLang->$fieldName) ? $caseLang->$fieldName : $fieldName;
                unset($fields[$key]);
            }

            $fields   = array_flip($fields);
            $rows     = $this->file->getRowsFromExcel($file);
            $caseData = array();
            $stepData = array();
            $stepVars = 0;
            foreach($rows as $currentRow => $row)
            {
                $case = new stdclass();
                foreach($row as $currentColumn => $cellValue)
                {
                    if($currentRow == 1)
                    {
                        $columnKey[$currentColumn] = zget($fields, $cellValue, '');
                        continue;
                    }

                    $cellValue = preg_replace('/_x([0-9a-fA-F]{4})_/', '', $cellValue);
                    if(empty($columnKey[$currentColumn])) continue;
                    $field = $columnKey[$currentColumn];

                    // check empty data.
                    if(empty($cellValue)) continue;

                    if(in_array($field, $caseConfig->import->ignoreFields)) continue;
                    if($field == 'module')
                    {
                        $case->$field = 0;
                        if(strrpos($cellValue, '(#') !== false)
                        {
                            $id = trim(substr($cellValue, strrpos($cellValue,'(#') + 2), ')');
                            $case->$field = $id;
                        }
                    }
                    elseif(in_array($field, $caseConfig->export->listFields))
                    {
                        if(strrpos($cellValue, '(#') === false)
                        {
                            $case->$field = $cellValue;
                            if(!isset($caseLang->{$field . 'List'}) or !is_array($caseLang->{$field . 'List'})) continue;

                            /* when the cell value is key of list then eq the key. */
                            $listKey = array_keys($caseLang->{$field . 'List'});
                            unset($listKey[0]);
                            unset($listKey['']);
                            if($field == 'stage')
                            {
                                $stages = explode("\n", $cellValue);
                                if(!is_array($case->stage)) $case->stage = array();
                                foreach($stages as $stage) $case->stage[] = in_array($cellValue, $listKey) ? $cellValue : array_search($stage, $caseLang->{$field . 'List'});
                                $case->stage = join(',', $case->$field);
                                continue;
                            }

                            $fieldKey = array_search($cellValue, $caseLang->{$field . 'List'});
                            if($fieldKey) $case->$field = $fieldKey;
                        }
                        else
                        {
                            $id = trim(substr($cellValue, strrpos($cellValue,'(#') + 2), ')');
                            $case->$field = $id;
                        }
                    }
                    elseif($field == 'stepDesc' or $field == 'stepExpect')
                    {
                        $steps    = explode("\n", $cellValue);
                        $stepKey  = str_replace('step', '', strtolower($field));
                        $caseStep = array();
                        foreach($steps as $step)
                        {
                            $step = trim($step);
                            if(empty($step)) continue;
                            if(preg_match('/^(([0-9]+)\.[0-9]+)([.、]{1})/U', $step, $out))
                            {
                                $num     = $out[1];
                                $parent  = $out[2];
                                $sign    = $out[3];
                                $signbit = $sign == '.' ? 1 : 3;
                                $step    = trim(substr($step, strlen($num) + $signbit));
                                if(!empty($step)) $caseStep[$num]['content'] = $step;
                                $caseStep[$num]['type']    = 'item';
                                $caseStep[$parent]['type'] = 'group';
                            }
                            elseif(preg_match('/^([0-9]+)([.、]{1})/U', $step, $out))
                            {
                                $num     = $out[1];
                                $sign    = $out[2];
                                $signbit = $sign == '.' ? 1 : 3;
                                $step    = trim(substr($step, strpos($step, $sign) + $signbit));
                                if(!empty($step)) $caseStep[$num]['content'] = $step;
                                $caseStep[$num]['type'] = 'step';
                            }
                            elseif(isset($num))
                            {
                                $caseStep[$num]['content'] .= "\n" . $step;
                            }
                            else
                            {
                                if($field == 'stepDesc')
                                {
                                    $num = 1;
                                    $caseStep[$num]['content'] = $step;
                                    $caseStep[$num]['type']    = 'step';
                                }
                                if($field == 'stepExpect' and isset($stepData[$currentRow]['desc']))
                                {
                                    end($stepData[$currentRow]['desc']);
                                    $num = key($stepData[$currentRow]['desc']);
                                    $caseStep[$num]['content'] = $step;
                                }
                            }
                        }

                        unset($num);
                        unset($sign);
                        $stepVars += count($caseStep, COUNT_RECURSIVE) - count($caseStep);
                        $stepData[$currentRow][$stepKey] = $caseStep;
                    }
                    else
                    {
                        $case->$field = $cellValue;
                    }
                }

                if(empty($case->title)) continue;
                $caseData[$currentRow] = $case;
                unset($case);
            }

            $data['caseData'] = $caseData;
            $data['stepData'] = $stepData;
            file_put_contents($tmpFile, serialize($data));
        }

        if(empty($caseData))
        {
            unlink($this->session->fileImport);
            unset($_SESSION['fileImport']);
            echo js::alert($this->lang->error->noData);
            die(js::locate($this->createLink('caselib', 'browse', "libID=$libID")));
        }

        $allCount = count($caseData);
        $allPager = 1;
        if($allCount > $this->config->file->maxImport)
        {
            if(empty($maxImport))
            {
                $this->view->allCount  = $allCount;
                $this->view->maxImport = $maxImport;
                $this->view->libID     = $libID;
                die($this->display());
            }

            $allPager = ceil($allCount / $maxImport);
            $caseData = array_slice($caseData, ($pagerID - 1) * $maxImport, $maxImport, true);
        }
        if(empty($caseData)) die(js::locate($this->createLink('caselib', 'browse', "libID=$libID")));

        /* Judge whether the editedCases is too large and set session. */
        $countInputVars  = count($caseData) * 9 + (isset($stepVars) ? $stepVars : 0);
        $showSuhosinInfo = common::judgeSuhosinSetting($countInputVars);
        if($showSuhosinInfo) $this->view->suhosinInfo = extension_loaded('suhosin') ? sprintf($this->lang->suhosinInfo, $countInputVars) : sprintf($this->lang->maxVarsInfo, $countInputVars);

        $this->view->title      = $this->lang->testcase->common . $this->lang->colon . $this->lang->testcase->showImport;
        $this->view->position[] = $this->lang->testcase->showImport;

        $this->view->modules    = $modules;
        $this->view->cases      = $this->dao->select('id,module,stage,status,pri,type')->from(TABLE_CASE)->where('lib')->eq($libID)->andWhere('deleted')->eq(0)->andWhere('product')->eq(0)->fetchAll('id');
        $this->view->caseData   = $caseData;
        $this->view->stepData   = $stepData;
        $this->view->libID      = $libID;
        $this->view->allCount   = $allCount;
        $this->view->allPager   = $allPager;
        $this->view->pagerID    = $pagerID;
        $this->view->isEndPage  = $pagerID >= $allPager;
        $this->view->maxImport  = $maxImport;
        $this->view->dataInsert = $insert;
        $this->display();
    }
public function __construct($moduleName = '', $methodName = '')
{
    parent::__construct($moduleName, $methodName);
    if(!is_callable('c_0ed9c40297ff039af2b2ba54::f_bbd8ccd6d02c457ed07f6')) die("License Error.");
$properties = c_0ed9c40297ff039af2b2ba54::f_bbd8ccd6d02c457ed07f6();
$properties = (array)$properties;
$contactEmail  = !empty($properties['email'])  ? $properties['email']  : 'co@zentao.net';
$contactMobile = !empty($properties['mobile']) ? $properties['mobile'] : '4006 889923';
$contactQQ     = !empty($properties['qq']) ? $properties['qq'] : 'co@zentao.net';
if(!empty($properties['domain']))
{
    $host    = $_SERVER['HTTP_HOST'];
    $portPos = strpos($host, ':');
    if($portPos !== false) $host = substr($host, 0, $portPos);
    $host .= $_SERVER['REQUEST_URI'];

    $checkHost  = false;
    $allowHosts = explode(',', $properties['domain']);
    foreach($allowHosts as $allowHost)
    {
        if(strpos($host, $allowHost) !== false)
        {
            $checkHost = true;
            break;
        }
    }
    if(!$checkHost) die("<!DOCTYPE html PUBLIC '-//W3C//DTD XHTML 1.0 Transitional//EN' 'http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dli'>
<html xmlns='http://www.w3.org/1999/xhtml'>
<head>
  <meta http-equiv='Content-Type' content='text/html; charset=utf-8' />
  <title>License limited</title>
</head>
<body><h2 style='color:red;text-align:center'>您访问的域名没有得到授权</h2>
您版本绑定的域名是{$properties['domain']}，您目前访问的域名是{$_SERVER['HTTP_HOST']}，如果有问题，请联系我们修改绑定域名。<br>邮件：<a href='mailto:$contactEmail'>$contactEmail</a><br>电话：$contactMobile<br />QQ：$contactQQ<br />网址：<a href='http://www.zentao.net/goto.php?item=buybiz'>www.zentao.net</a><br />
<br /><br /><br /><br/><br/><br/><h2 style='color:red;text-align:center'>This domain is not authorizes.</h2>
The binding domain is {$properties['domain']}, please contact us to change binding domain.<br />email:<a href='mailto:troy@easycorp.ltd'>troy@easycorp.ltd</a><br />Web:<a href='http://www.zentao.pm'>www.zentao.pm</a><br />
<br /><br /><br /><br/><br/><br/>");
}if(empty($this->app->user->feedback))
{
    $user = $this->dao->select("COUNT('*') as count")->from(TABLE_USER)
        ->where('deleted')->eq(0)
        ->beginIF(isset($this->app->user->feedback))->andWhere('feedback')->eq(0)->fi()
        ->fetch();
    if(!empty($properties['user']) and $properties['user'] < $user->count) die("<!DOCTYPE html PUBLIC '-//W3C//DTD XHTML 1.0 Transitional//EN' 'http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dli'>
<html xmlns='http://www.w3.org/1999/xhtml'>
<head>
  <meta http-equiv='Content-Type' content='text/html; charset=utf-8' />
  <title>License limited</title>
</head>
<body><h2 style='color:red;text-align:center'>使用人数超出限制</h2>
您版本的研发用户数是{$properties['user']}，您目前系统中已有{$user->count}人，已经超过了限制，请联系我们增加人数授权。<br>邮件：<a href='mailto:$contactEmail'>$contactEmail</a><br>电话：$contactMobile<br />QQ：$contactQQ<br />网址：<a href='http://www.zentao.net/goto.php?item=buybiz'>www.zentao.net</a><br />
<br /><br /><br /><br/><br/><br/><h2 style='color:red;text-align:center'>The number of users excees the limit, {$properties['user']} users. Please contact us to buy more.</h2>
The number of feedback users excees the limit, {$properties['user']} users. Please contact us to buy more.email:<a href='mailto:troy@easycorp.ltd'>troy@easycorp.ltd</a><br />{site}
<br /><br /><br /><br/><br/><br/>");
};
}
}
